/* vodsp - simple svgalib triggering-oscilloscope-like program
 * Public domain by Russell Marks.
 */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <vga.h>
#include <vgagl.h>


int main(void)
{
static unsigned char buf[256];
GraphicsContext *realscrn;
int audio,tmp,x,y,oldy,f;
int start,maxdiff,maxpos;

vga_init();

if((audio=open("/dev/dsp",O_RDONLY))<0)
  fprintf(stderr,"vodsp: couldn't open /dev/dsp.\n"),exit(1);

tmp=0x80008;		/* 8 frags, 256 bytes, 31.25/sec */
ioctl(audio,SNDCTL_DSP_SETFRAGMENT,&tmp);

vga_setmode(G320x200x256);
gl_setcontextvga(vga_getcurrentmode());
realscrn=gl_allocatecontext();
gl_getcontext(realscrn);
gl_setcontextvgavirtual(vga_getcurrentmode());
gl_clearscreen(0);

oldy=100;

while(1)
  {
  read(audio,buf,256);
  
  gl_clearscreen(0);
  gl_hline(0,100-64,319,20);
  gl_hline(0,100   ,319,20);
  gl_hline(0,100+64,319,20);

  /* trigger on the highest (then earliest) gradient between samples */
  start=0; maxdiff=maxpos=0;
  
  for(f=96;f>0;f--)
    {
    if(buf[f]>buf[f-1] && (tmp=(buf[f]-buf[f-1]))>=maxdiff)
      {
      maxdiff=tmp;
      maxpos=f-1;
      }
    }
  
  start=maxpos;

  if(start>0) oldy=100-((buf[start-1]-128)/2);
  
  for(x=2,f=start;f<256 && x<320;f++,x+=2,oldy=y)
    {
    y=100-((buf[f]-128)/2);
    if(oldy==y)
      gl_hline(x-2,y,x,31);
    else
      gl_line(x-2,oldy,x,y,31);
    }
  
  /* copy to screen */
  gl_copyscreen(realscrn);
  }
}
